#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,16,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display
// the setup routine runs once when you press reset:
 int sensorPin = A0;
  float ntu;
  float volt;

// the setup routine runs once when you press reset:
void setup() {
 
  // initialize serial communication at 9600 bits per second:
  
  lcd.init();                      // initialize the lcd 
  lcd.backlight();
  Serial.begin(9600);

}
 
// the loop routine runs over and over again forever:
void loop() {
  // read the input on analog pin 0:

  volt = 0;
  for (int i=0; i<800;i++)
  {
    volt += ((float)analogRead(sensorPin)/1023)*5;
  }
  volt = volt/800;
  volt = round_to_dp(volt,2);
  if(volt<0.00001){
    ntu = 3000;
  }else{
    //  Fill the formula for NTU in ntu = c*pow(volt,2)+d*volt+e;
    // For the values of c, d, e use the python script and the volt measurements
    ntu = 2.64*pow(volt,2)-20.26*volt+37.86;
    }
    //The lcd screen can show the average of 25 ntu values by writing the following code
  int sensorValue = analogRead(A0);
  int count = 25;
  int raw = 0;
  for (int i=0; i<count;i++) raw +=analogRead(A0);
  raw = raw/count;
 
  // print out the value you read by sending it to the lcd screen:
  Serial.println(sensorValue);
  delay(1);  // delay in between reads for stability
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("NTU =");
  lcd.print(ntu);
  // lcd.setCursor(0,1);
  // lcd.print("Volt =");
  // lcd.print(volt);
  // lcd.print(ntu);
  delay(500);
}
float round_to_dp( float in_value, int decimal_place )
{
  float multiplier = powf( 10.0f, decimal_place );
  in_value = roundf( in_value * multiplier ) / multiplier;
  return in_value;
}
